Index: /branches/2.2/filemanager/inc/class.uifilemanager.inc.php
===================================================================
--- /branches/2.2/filemanager/inc/class.uifilemanager.inc.php	(revision 3610)
+++ /branches/2.2/filemanager/inc/class.uifilemanager.inc.php	(revision 3638)
@@ -1034,176 +1037,205 @@
 				});</script>';
 
-				}
-
-
-				$this->t->set_var($vars);
-				$this->t->parse('rows','row');
-				$this->t->pparse('out','row');
-
-			}
-
-		}
-
-		function history()
-		{
-			if($this->file) // FIXME this-file is never defined
-			{
-				$journal_array = $this->bo->vfs->get_journal(array(
-					'string'	=> $this->file,//FIXME
-					'relatives'	=> array(RELATIVE_ALL)
-				));
-
-				if(is_array($journal_array))
+			}
+
+
+			$this->t->set_var($vars);
+			$this->t->parse('rows','row');
+			$this->t->pparse('out','row');
+
+		}
+
+	}
+
+	function history()
+	{
+		if($this->file) // FIXME this-file is never defined
+		{
+			$journal_array = $this->bo->vfs->get_journal(array(
+				'string'	=> $this->file,//FIXME
+				'relatives'	=> array(RELATIVE_ALL)
+			));
+
+			if(is_array($journal_array))
+			{
+				$this->html_table_begin();
+				$this->html_table_row_begin();
+				$this->html_table_col_begin();
+				echo lang('Date');
+				$this->html_table_col_end();
+				$this->html_table_col_begin();
+				echo lang('Version');
+				$this->html_table_col_end();
+				$this->html_table_col_begin();
+				echo lang('Who');
+				$this->html_table_col_end();
+				$this->html_table_col_begin();
+				echo lang('Operation');
+				$this->html_table_col_end();
+				$this->html_table_row_end();
+
+				while(list($num, $journal_entry) = each($journal_array))
 				{
-					$this->html_table_begin();
 					$this->html_table_row_begin();
 					$this->html_table_col_begin();
-					echo lang('Date');
+					$this->bo->html_text($journal_entry['created'] . '&nbsp;&nbsp;&nbsp;');
 					$this->html_table_col_end();
 					$this->html_table_col_begin();
-					echo lang('Version');
+					$this->bo->html_text($journal_entry['version'] . '&nbsp;&nbsp;&nbsp;' );
 					$this->html_table_col_end();
 					$this->html_table_col_begin();
-					echo lang('Who');
+					$this->bo->html_text($GLOBALS['phpgw']->accounts->id2name($journal_entry['owner_id']) . '&nbsp;&nbsp;&nbsp;');
 					$this->html_table_col_end();
 					$this->html_table_col_begin();
-					echo lang('Operation');
+					$this->bo->html_text($journal_entry['comment']);
 					$this->html_table_col_end();
-					$this->html_table_row_end();
-
-					while(list($num, $journal_entry) = each($journal_array))
-					{
-						$this->html_table_row_begin();
-						$this->html_table_col_begin();
-						$this->bo->html_text($journal_entry['created'] . '&nbsp;&nbsp;&nbsp;');
-						$this->html_table_col_end();
-						$this->html_table_col_begin();
-						$this->bo->html_text($journal_entry['version'] . '&nbsp;&nbsp;&nbsp;' );
-						$this->html_table_col_end();
-						$this->html_table_col_begin();
-						$this->bo->html_text($GLOBALS['phpgw']->accounts->id2name($journal_entry['owner_id']) . '&nbsp;&nbsp;&nbsp;');
-						$this->html_table_col_end();
-						$this->html_table_col_begin();
-						$this->bo->html_text($journal_entry['comment']);
-						$this->html_table_col_end();
-					}
-
-					$this->html_table_end();
-					$GLOBALS['phpgw']->common->phpgw_footer();
-					$GLOBALS['phpgw']->common->phpgw_exit();
 				}
-				else
-				{
-					echo lang('No version history for this file/directory');
-				}
-			}
-		}
-		function view()
-		{
-			if (!$this->bo->vfs->acl_check(array(
-				'string'        => $this->path,
+
+				$this->html_table_end();
+				$GLOBALS['phpgw']->common->phpgw_footer();
+				$GLOBALS['phpgw']->common->phpgw_exit();
+			}
+			else
+			{
+				echo lang('No version history for this file/directory');
+			}
+		}
+	}
+	function view()
+	{
+		if (!$this->bo->vfs->acl_check(array(
+			'string'        => $this->path,
+			'relatives'     => array(RELATIVE_NONE),
+			'operation'     => PHPGW_ACL_READ
+		)))
+		{
+			$this->messages[] = lang("You have no permission to access this file");
+			header('Location:'.$this->encode_href('inc/index.php?menuaction=filemanager.uifilemanager.index','&path='.base64_encode($this->bo->homedir)));
+
+			return;
+		}
+		if($this->file) //FIXME
+		{
+			$ls_array = $this->bo->vfs->ls(array(
+				'string'	=> $this->path.'/'.$this->file,//FIXME
+				'relatives'	=> array(RELATIVE_NONE),
+				'checksubdirs'	=> False,
+				'nofiles'	=> True
+			));
+			if($ls_array[0]['mime_type'])
+			{
+				$mime_type = $ls_array[0]['mime_type'];
+			}
+			elseif($this->prefs['viewtextplain'])
+			{
+				$mime_type = 'text/plain';
+			}
+			$viewable = array('text/plain','text/csv','text/html',
+				'text/text','image/jpeg','image/png','image/gif',
+				'audio/mpeg','video/mpeg');
+
+			if(in_array($mime_type,$viewable)) 
+			{
+				/*Note: if you put application/octet-stream you force download */
+				header('Content-type: ' . $mime_type);
+				header('Content-disposition: filename="' . addslashes($this->file) . '"');
+				Header("Pragma: public");
+			}
+			else
+			{
+				$GLOBALS['phpgw']->browser->content_header($this->file,$mime_type,$ls_array[0]['size']);
+			}
+			if ($ls_array[0]['size'] < 10240)
+			{
+				echo $this->bo->vfs->read(array(
+					'string'    => $this->path.'/'.$this->file,//FIXME
+					'relatives'    => array(RELATIVE_NONE)
+				));
+			}
+			else
+			{
+				$this->bo->vfs->print_content(array(
+					'string' => $this->path.'/'.$this->file,
+					'relatives' => array(RELATIVE_NONE)
+				)
+			);
+			}
+			$GLOBALS['phpgw']->common->phpgw_exit();
+		}
+	}
+
+	function export(){
+		if($this->file)
+		{
+			$ls_array = $this->bo->vfs->ls(array(
+				'string'        => $this->path.'/'.$this->file,
 				'relatives'     => array(RELATIVE_NONE),
-				'operation'     => PHPGW_ACL_READ
-			)))
-			{
-				$this->messages[] = lang("You have no permission to access this file");
-				header('Location:'.$this->encode_href('inc/index.php?menuaction=filemanager.uifilemanager.index','&path='.base64_encode($this->bo->homedir)));
-
-				return;
-			}
-			if($this->file) //FIXME
-			{
-				$ls_array = $this->bo->vfs->ls(array(
-					'string'	=> $this->path.'/'.$this->file,//FIXME
-					'relatives'	=> array(RELATIVE_NONE),
-					'checksubdirs'	=> False,
-					'nofiles'	=> True
-				));
-				if($ls_array[0]['mime_type'])
-				{
-					$mime_type = $ls_array[0]['mime_type'];
-				}
-				elseif($this->prefs['viewtextplain'])
-				{
-					$mime_type = 'text/plain';
-				}
-				$viewable = array('text/plain','text/csv','text/html',
-					'text/text','image/jpeg','image/png','image/gif',
-					'audio/mpeg','video/mpeg');
-
-				if(in_array($mime_type,$viewable)) 
-				{
-					/*Note: if you put application/octet-stream you force download */
-					header('Content-type: ' . $mime_type);
-					header('Content-disposition: filename="' . addslashes($this->file) . '"');
-					Header("Pragma: public");
-				}
-				else
-				{
-					$GLOBALS['phpgw']->browser->content_header($this->file,$mime_type,$ls_array[0]['size']);
-				}
-				if ($ls_array[0]['size'] < 10240)
-				{
-					echo $this->bo->vfs->read(array(
-						'string'    => $this->path.'/'.$this->file,//FIXME
-						'relatives'    => array(RELATIVE_NONE)
-					));
-				}
-				else
-				{
-					$this->bo->vfs->print_content(array(
-						'string' => $this->path.'/'.$this->file,
-						'relatives' => array(RELATIVE_NONE)
-					)
-				);
-				}
-				$GLOBALS['phpgw']->common->phpgw_exit();
-			}
-		}
-
-		function export(){
-			if($this->file)
-			{
-				$ls_array = $this->bo->vfs->ls(array(
-					'string'        => $this->path.'/'.$this->file,
-					'relatives'     => array(RELATIVE_NONE),
-					'checksubdirs'  => False,
-					'nofiles'       => True
-				));
-				/*$timestamp = $this->vfs_functions->dateString2timeStamp($ls_array[0]['modified']);
-				if (time() - $timestamp < 60 && $ls_array[0]['modifiedby_id'] != $GLOBALS['phpgw_info']['user']['account_id']);
-				{
-					// recently than last minute: someone is editing
-				}*/
-				$mime_type = $ls_array[0]['mime_type'];
-				$formats = array('text/html');
-				if(!in_array($mime_type,$formats)){
-					echo lang('Impossible to export this file');
-					return False;
-				}
-				$content = $this->bo->vfs->read(array('string' => $this->path.'/'.$this->file,
-					       'relatives'     => array(RELATIVE_NONE)
-				       ));
-
-				include_once('filemanager/tp/dompdf/dompdf_config.inc.php');
-				$dompdf = new DOMPDF();
-				$dompdf->load_html($content);
-				$dompdf->set_paper($this->prefs['pdf_paper_type'], $this->prefs['pdf_type']);
-				/* Would be nice to implement 'Title','Subject','Author','Creator','CreationDate'*/
-				$dompdf->render();
-				$dompdf->stream(strtok($this->file,'.').".pdf");
-				$GLOBALS['phpgw']->common->phpgw_exit();
-			}
-		}
-
-		//give back an array with all directories except current and dirs that are not accessable
-		function all_other_directories()
-		{
-			# First we get the directories in their home directory
-			$dirs = array();
-			$dirs[] = array('directory' => $this->bo->fakebase, 'name' => $this->bo->userinfo['account_lid']);
+				'checksubdirs'  => False,
+				'nofiles'       => True
+			));
+			/*$timestamp = $this->vfs_functions->dateString2timeStamp($ls_array[0]['modified']);
+			if (time() - $timestamp < 60 && $ls_array[0]['modifiedby_id'] != $GLOBALS['phpgw_info']['user']['account_id']);
+			{
+				// recently than last minute: someone is editing
+			}*/
+			$mime_type = $ls_array[0]['mime_type'];
+			$formats = array('text/html');
+			if(!in_array($mime_type,$formats)){
+				echo lang('Impossible to export this file');
+				return False;
+			}
+			$content = $this->bo->vfs->read(array('string' => $this->path.'/'.$this->file,
+				       'relatives'     => array(RELATIVE_NONE)
+			       ));
+
+			include_once('filemanager/tp/dompdf/dompdf_config.inc.php');
+			$dompdf = new DOMPDF();
+			$dompdf->load_html($content);
+			$dompdf->set_paper($this->prefs['pdf_paper_type'], $this->prefs['pdf_type']);
+			/* Would be nice to implement 'Title','Subject','Author','Creator','CreationDate'*/
+			$dompdf->render();
+			$dompdf->stream(strtok($this->file,'.').".pdf");
+			$GLOBALS['phpgw']->common->phpgw_exit();
+		}
+	}
+
+	//give back an array with all directories except current and dirs that are not accessable
+	function all_other_directories()
+	{
+		# First we get the directories in their home directory
+		$dirs = array();
+		$dirs[] = array('directory' => $this->bo->fakebase, 'name' => $this->bo->userinfo['account_lid']);
+
+		$tmp_arr=array(
+			'string'	=> $this->bo->homedir,
+			'relatives'	=> array(RELATIVE_NONE),
+			'checksubdirs'	=> True,
+			'mime_type'	=> 'Directory'
+		);
+
+		$ls_array = $this->bo->vfs->ls($tmp_arr,True);
+
+		while(list($num, $dir) = each($ls_array))
+		{
+			$dirs[] = $dir;
+		}
+
+
+		# Then we get the directories in their readable groups' home directories
+		reset($this->readable_groups);
+		while(list($num, $group_array) = each($this->readable_groups))
+		{
+			// Don't list directories for groups that don't exists
+			$test=$this->bo->vfs->get_real_info(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],
+				'relatives' => array(RELATIVE_NONE), 'relative' => False));
+			if($test[mime_type]!='Directory')
+			{
+				continue;
+			}
+
+			$dirs[] = array('directory' => $this->bo->fakebase, 'name' => $group_array['account_name']);
 
 			$tmp_arr=array(
-				'string'	=> $this->bo->homedir,
+				'string'	=> $this->bo->fakebase.'/'.$group_array['account_name'],
 				'relatives'	=> array(RELATIVE_NONE),
 				'checksubdirs'	=> True,
@@ -1212,362 +1244,333 @@
 
 			$ls_array = $this->bo->vfs->ls($tmp_arr,True);
-
 			while(list($num, $dir) = each($ls_array))
 			{
 				$dirs[] = $dir;
 			}
-
-
-			# Then we get the directories in their readable groups' home directories
-			reset($this->readable_groups);
-			while(list($num, $group_array) = each($this->readable_groups))
-			{
-				// Don't list directories for groups that don't exists
-				$test=$this->bo->vfs->get_real_info(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],
-					'relatives' => array(RELATIVE_NONE), 'relative' => False));
-				if($test[mime_type]!='Directory')
+		}
+		reset($dirs);
+		while(list($num, $dir) = each($dirs))
+		{
+			if(!$dir['directory'])
+			{
+				continue;
+			}
+
+			# So we don't display //
+			if($dir['directory'] != '/')
+			{
+				$dir['directory'] .= '/';
+			}
+			$return[] = $dir;
+		}
+		return $return;
+	}
+
+	function update_groups()
+	{
+		# Get their readable groups to be used throughout the script
+		$acl = array();
+		$groups = array();
+		$acl = $GLOBALS['phpgw']->acl->get_ids_for_location($GLOBALS['phpgw_info']['user']['account_id'],1,'filemanager');
+		if (is_array($acl))
+			foreach($acl as $key => $value){
+				$info = array();
+				$info = $GLOBALS['phpgw']->accounts->get_account_data($value);
+				$groups[$key]['account_id'] = $value;
+				$groups[$key]['account_lid'] = $info[$value]['lid'];
+				$groups[$key]['account_name'] = $info[$value]['firstname'];
+				$groups[$key]['account_lastname'] = $info[$value]['lastname'];
+				$groups[$key]['account_fullname'] = $info[$value]['fullname'];
+			}
+		$this->readable_groups = array();
+		while(list($num, $account) = each($groups))
+		{
+			if($this->bo->vfs->acl_check(array('owner_id' => $account['account_id'],'operation' => PHPGW_ACL_READ)))
+			{
+				$this->readable_groups[$account['account_lid']] = Array('account_id' => $account['account_id'], 'account_name' => $account['account_lid']);
+			}
+		}
+
+	}
+	function search()
+	{
+		/* TODO this is a primitive search */
+		$this->update_groups();
+   			$this->dirs = $this->all_other_directories();
+		$path = $this->path;
+		if (strlen($this->text) > 3)
+		{                                                                
+			$this->text = strtoupper($this->text);
+			foreach($this->dirs as $elem)
+			{
+				$this->path = $elem['directory'].$elem['name'];
+				reset($this->files_array);
+	                        $this->readFilesInfo();
+				for($i = 0; $i < count($this->files_array); $i++)
 				{
-					continue;
+					$comment = strtoupper($this->files_array[$i]['comment']);
+					$name = strtoupper($this->files_array[$i]['name']);
+					if (strstr($name,$this->text) ||
+					strstr($comment,$this->text) ){
+						$return[$this->files_array[$i]['directory'].$name] = $this->files_array[$i];
+						$return[$this->files_array[$i]['directory'].$name]['icon'] = $this->mime_icon($this->files_array[$i]['mime_type']);
+					}
 				}
-
-				$dirs[] = array('directory' => $this->bo->fakebase, 'name' => $group_array['account_name']);
-
-				$tmp_arr=array(
-					'string'	=> $this->bo->fakebase.'/'.$group_array['account_name'],
-					'relatives'	=> array(RELATIVE_NONE),
-					'checksubdirs'	=> True,
-					'mime_type'	=> 'Directory'
-				);
-
-				$ls_array = $this->bo->vfs->ls($tmp_arr,True);
-				while(list($num, $dir) = each($ls_array))
+				if (count($return) > 50)
 				{
-					$dirs[] = $dir;
+					$return = array_slice($return,0,50);
+					break;
 				}
-			}
-			reset($dirs);
-			while(list($num, $dir) = each($dirs))
-			{
-				if(!$dir['directory'])
-				{
-					continue;
-				}
-
-				# So we don't display //
-				if($dir['directory'] != '/')
-				{
-					$dir['directory'] .= '/';
-				}
-				$return[] = $dir;
-			}
-			return $return;
-		}
-
-		function update_groups()
-		{
-			# Get their readable groups to be used throughout the script
-			$acl = array();
-			$groups = array();
-			$acl = $GLOBALS['phpgw']->acl->get_ids_for_location($GLOBALS['phpgw_info']['user']['account_id'],1,'filemanager');
-			if (is_array($acl))
-				foreach($acl as $key => $value){
-					$info = array();
-					$info = $GLOBALS['phpgw']->accounts->get_account_data($value);
-					$groups[$key]['account_id'] = $value;
-					$groups[$key]['account_lid'] = $info[$value]['lid'];
-					$groups[$key]['account_name'] = $info[$value]['firstname'];
-					$groups[$key]['account_lastname'] = $info[$value]['lastname'];
-					$groups[$key]['account_fullname'] = $info[$value]['fullname'];
-				}
-			$this->readable_groups = array();
-			while(list($num, $account) = each($groups))
-			{
-				if($this->bo->vfs->acl_check(array('owner_id' => $account['account_id'],'operation' => PHPGW_ACL_READ)))
-				{
-					$this->readable_groups[$account['account_lid']] = Array('account_id' => $account['account_id'], 'account_name' => $account['account_lid']);
-				}
-			}
-
-		}
-		function search()
-		{
-			/* TODO this is a primitive search */
-			$this->update_groups();
-       			$this->dirs = $this->all_other_directories();
-			$path = $this->path;
-			if (strlen($this->text) > 3)
-			{                                                                
-				$this->text = strtoupper($this->text);
-				foreach($this->dirs as $elem)
-				{
-					$this->path = $elem['directory'].$elem['name'];
-					reset($this->files_array);
-		                        $this->readFilesInfo();
-					for($i = 0; $i < count($this->files_array); $i++)
-					{
-						$comment = strtoupper($this->files_array[$i]['comment']);
-						$name = strtoupper($this->files_array[$i]['name']);
-						if (strstr($name,$this->text) ||
-						strstr($comment,$this->text) ){
-							$return[$this->files_array[$i]['directory'].$name] = $this->files_array[$i];
-							$return[$this->files_array[$i]['directory'].$name]['icon'] = $this->mime_icon($this->files_array[$i]['mime_type']);
-						}
-					}
-					if (count($return) > 50)
-					{
-						$return = array_slice($return,0,50);
-						break;
-					}
-				}	
-			}
-			echo serialize(array_values($return));
-		}
-
-		/* seek icon for mimetype else return an unknown icon */
-		function mime_icon($mime_type, $size=16)
-		{
-			if(!$mime_type) $mime_type='unknown';
-
-			$mime_type=str_replace	('/','_',$mime_type);
-
-			$img=$GLOBALS['phpgw']->common->image('filemanager','mime'.$size.'_'.strtolower($mime_type));
-			if(!$img) $img=$GLOBALS['phpgw']->common->image('filemanager','mime'.$size.'_unknown');
-
-			return $img;
-		}
-
-		function toolButton($link,$img='',$description='')
-		{
-			$image=$GLOBALS['phpgw']->common->image('filemanager','button_'.strtolower($img));
-
-			if($img)
-			{
-				return '<span name="'.$link.'" class="toolButton" onclick="toolbar.control(\''.$link.'\',this);" title="'.$description.'"><img src="'.$image.'" alt="'.$description.'"/></a><small>'.$description.'</small></span>';
-			}
-		}
-
-		function inputButton($name,$img='',$description='')
-		{
-			$image=$GLOBALS['phpgw']->common->image('filemanager','button_'.strtolower($img));
-
-			if($img)
-			{
-				return '<td class="" align="center" valign="middle" height="28" width="70">
-				<input title="'.$description.'" name="'.$name.'" type="image" alt="'.$name.'" src="'.$image.'" value="clicked" /><br><small>'.$description.'</small>
-				</td>';
-			}
-		}
-
-
-		function html_form_input($type = NULL, $name = NULL, $value = NULL, $maxlength = NULL, $size = NULL, $checked = NULL, $string = '', $return = 1)
-		{
-			$text = ' ';
-			if($type != NULL && $type)
-			{
-				if($type == 'checkbox')
-				{
-					$value = $this->bo->string_encode($value, 1);
-				}
-				$text .= 'type="'.$type.'" ';
-			}
-			if($name != NULL && $name)
-			{
-				$text .= 'name="'.$name.'" ';
-			}
-			if($value != NULL && $value)
-			{
-				$text .= 'value="'.$value.'" ';
-			}
-			if(is_int($maxlength) && $maxlength >= 0)
-			{
-				$text .= 'maxlength="'.$maxlength.'" ';
-			}
-			if(is_int($size) && $size >= 0)
-			{
-				$text .= 'size="'.$size.'" ';
-			}
-			if($checked != NULL && $checked)
-			{
-				$text .= 'checked ';
-			}
-
-			return '<input'.$text.$string.'>';
-		}
-
-		function html_form_option($value = NULL, $displayed = NULL, $selected = NULL, $return = 0)
-		{
-			$text = ' ';
-			if($value != NULL && $value)
-			{
-				$text .= ' value="'.$value.'" ';
-			}
-			if($selected != NULL && $selected)
-			{
-				$text .= ' selected';
-			}
-			return  '<option'.$text.'>'.$displayed.'</option>';
-		}
-
-		function encode_href($href = NULL, $args = NULL , $extra_args)
+			}	
+		}
+		echo serialize(array_values($return));
+	}
+
+	/* seek icon for mimetype else return an unknown icon */
+	function mime_icon($mime_type, $size=16)
+	{
+		if(!$mime_type) $mime_type='unknown';
+
+		$mime_type=str_replace	('/','_',$mime_type);
+
+		$img=$GLOBALS['phpgw']->common->image('filemanager','mime'.$size.'_'.strtolower($mime_type));
+		if(!$img) $img=$GLOBALS['phpgw']->common->image('filemanager','mime'.$size.'_unknown');
+
+		return $img;
+	}
+
+	function toolButton($link,$img='',$description='')
+	{
+		$image=$GLOBALS['phpgw']->common->image('filemanager','button_'.strtolower($img));
+
+		if($img)
+		{
+			return '<span name="'.$link.'" class="toolButton" onclick="toolbar.control(\''.$link.'\',this);" title="'.$description.'"><img src="'.$image.'" alt="'.$description.'"/></a><small>'.$description.'</small></span>';
+		}
+	}
+
+	function inputButton($name,$img='',$description='')
+	{
+		$image=$GLOBALS['phpgw']->common->image('filemanager','button_'.strtolower($img));
+
+		if($img)
+		{
+			return '<td class="" align="center" valign="middle" height="28" width="70">
+			<input title="'.$description.'" name="'.$name.'" type="image" alt="'.$name.'" src="'.$image.'" value="clicked" /><br><small>'.$description.'</small>
+			</td>';
+		}
+	}
+
+
+	function html_form_input($type = NULL, $name = NULL, $value = NULL, $maxlength = NULL, $size = NULL, $checked = NULL, $string = '', $return = 1)
+	{
+		$text = ' ';
+		if($type != NULL && $type)
+		{
+			if($type == 'checkbox')
+			{
+				$value = $this->bo->string_encode($value, 1);
+			}
+			$text .= 'type="'.$type.'" ';
+		}
+		if($name != NULL && $name)
+		{
+			$text .= 'name="'.$name.'" ';
+		}
+		if($value != NULL && $value)
+		{
+			$text .= 'value="'.$value.'" ';
+		}
+		if(is_int($maxlength) && $maxlength >= 0)
+		{
+			$text .= 'maxlength="'.$maxlength.'" ';
+		}
+		if(is_int($size) && $size >= 0)
+		{
+			$text .= 'size="'.$size.'" ';
+		}
+		if($checked != NULL && $checked)
+		{
+			$text .= 'checked ';
+		}
+
+		return '<input'.$text.$string.'>';
+	}
+
+	function html_form_option($value = NULL, $displayed = NULL, $selected = NULL, $return = 0)
+	{
+		$text = ' ';
+		if($value != NULL && $value)
+		{
+			$text .= ' value="'.$value.'" ';
+		}
+		if($selected != NULL && $selected)
+		{
+			$text .= ' selected';
+		}
+		return  '<option'.$text.'>'.$displayed.'</option>';
+	}
+
+	function encode_href($href = NULL, $args = NULL , $extra_args)
+	{
+		$href = $this->bo->string_encode($href, 1);
+		$all_args = $args.'&'.$this->bo->string_encode($extra_args, 1);
+
+		$address = $GLOBALS['phpgw']->link($href, $all_args);
+
+		return $address;
+	}
+
+	function html_link($href = NULL, $args = NULL , $extra_args, $text = NULL, $return = 1, $encode = 1, $linkonly = 0, $target = NULL)
+	{
+		//	unset($encode);
+		if($encode)
 		{
 			$href = $this->bo->string_encode($href, 1);
 			$all_args = $args.'&'.$this->bo->string_encode($extra_args, 1);
-
+		}
+		else
+		{
+			//				$href = $this->bo->string_encode($href, 1);
+			$all_args = $args.'&'.$extra_args;
+		}
+		###
+		# This decodes / back to normal
+		###
+		//			$all_args = preg_replace("/%2F/", "/", $all_args);
+		//			$href = preg_replace("/%2F/", "/", $href);
+
+		/* Auto-detect and don't disturb absolute links */
+		if(!preg_match("|^http(.{0,1})://|", $href))
+		{
+			//Only add an extra / if there isn't already one there
+
+			// die(SEP);
+			if(!($href[0] == SEP))
+			{
+				$href = SEP . $href;
+			}
+
+			/* $phpgw->link requires that the extra vars be passed separately */
+			//				$link_parts = explode("?", $href);
 			$address = $GLOBALS['phpgw']->link($href, $all_args);
-
-			return $address;
-		}
-
-		function html_link($href = NULL, $args = NULL , $extra_args, $text = NULL, $return = 1, $encode = 1, $linkonly = 0, $target = NULL)
-		{
-			//	unset($encode);
-			if($encode)
-			{
-				$href = $this->bo->string_encode($href, 1);
-				$all_args = $args.'&'.$this->bo->string_encode($extra_args, 1);
-			}
-			else
-			{
-				//				$href = $this->bo->string_encode($href, 1);
-				$all_args = $args.'&'.$extra_args;
-			}
-			###
-			# This decodes / back to normal
-			###
-			//			$all_args = preg_replace("/%2F/", "/", $all_args);
-			//			$href = preg_replace("/%2F/", "/", $href);
-
-			/* Auto-detect and don't disturb absolute links */
-			if(!preg_match("|^http(.{0,1})://|", $href))
-			{
-				//Only add an extra / if there isn't already one there
-
-				// die(SEP);
-				if(!($href[0] == SEP))
-				{
-					$href = SEP . $href;
-				}
-
-				/* $phpgw->link requires that the extra vars be passed separately */
-				//				$link_parts = explode("?", $href);
-				$address = $GLOBALS['phpgw']->link($href, $all_args);
-				//				$address = $GLOBALS['phpgw']->link($href);
-			}
-			else
-			{
-				$address = $href;
-			}
-
-			/* If $linkonly is set, don't add any HTML */
-			if($linkonly)
-			{
-				$rstring = $address;
-			}
-			else
-			{
-				if($target)
-				{
-					$target = 'target='.$target;
-				}
-
-				$text = trim($text);
-				$rstring = '<a href="'.$address.'" '.$target.'>'.$text.'</a>';
-			}
-
-			return($this->bo->eor($rstring, $return));
-		}
-
-		function html_table_begin($width = NULL, $border = NULL, $cellspacing = NULL, $cellpadding = NULL, $rules = NULL, $string = '', $return = 0)
-		{
-			if($width != NULL && $width)
-			{
-				$width = "width=$width";
-			}
-			if(is_int($border) && $border >= 0)
-			{
-				$border = "border=$border";
-			}
-			if(is_int($cellspacing) && $cellspacing >= 0)
-			{
-				$cellspacing = "cellspacing=$cellspacing";
-			}
-			if(is_int($cellpadding) && $cellpadding >= 0)
-			{
-				$cellpadding = "cellpadding=$cellpadding";
-			}
-			if($rules != NULL && $rules)
-			{
-				$rules = "rules=$rules";
-			}
-
-			$rstring = "<table $width $border $cellspacing $cellpadding $rules $string>";
-			return($this->bo->eor($rstring, $return));
-		}
-
-		function html_table_end($return = 0)
-		{
-			$rstring = "</table>";
-			return($this->bo->eor($rstring, $return));
-		}
-
-		function html_table_row_begin($align = NULL, $halign = NULL, $valign = NULL, $bgcolor = NULL, $string = '', $return = 0)
-		{
-			if($align != NULL && $align)
-			{
-				$align = "align=$align";
-			}
-			if($halign != NULL && $halign)
-			{
-				$halign = "halign=$halign";
-			}
-			if($valign != NULL && $valign)
-			{
-				$valign = "valign=$valign";
-			}
-			if($bgcolor != NULL && $bgcolor)
-			{
-				$bgcolor = "bgcolor=$bgcolor";
-			}
-			$rstring = "<tr $align $halign $valign $bgcolor $string>";
-			return($this->bo->eor($rstring, $return));
-		}
-
-		function html_table_row_end($return = 0)
-		{
-			$rstring = "</tr>";
-			return($this->bo->eor($rstring, $return));
-		}
-
-		function html_table_col_begin($align = NULL, $halign = NULL, $valign = NULL, $rowspan = NULL, $colspan = NULL, $string = '', $return = 0)
-		{
-			if($align != NULL && $align)
-			{
-				$align = "align=$align";
-			}
-			if($halign != NULL && $halign)
-			{
-				$halign = "halign=$halign";
-			}
-			if($valign != NULL && $valign)
-			{
-				$valign = "valign=$valign";
-			}
-			if(is_int($rowspan) && $rowspan >= 0)
-			{
-				$rowspan = "rowspan=$rowspan";
-			}
-			if(is_int($colspan) && $colspan >= 0)
-			{
-				$colspan = "colspan=$colspan";
-			}
-
-			$rstring = "<td $align $halign $valign $rowspan $colspan $string>";
-			return($this->bo->eor($rstring, $return));
-		}
-
-		function html_table_col_end($return = 0)
-		{
-			$rstring = "</td>";
-			return($this->bo->eor($rstring, $return));
-		}
-	}
+			//				$address = $GLOBALS['phpgw']->link($href);
+		}
+		else
+		{
+			$address = $href;
+		}
+
+		/* If $linkonly is set, don't add any HTML */
+		if($linkonly)
+		{
+			$rstring = $address;
+		}
+		else
+		{
+			if($target)
+			{
+				$target = 'target='.$target;
+			}
+
+			$text = trim($text);
+			$rstring = '<a href="'.$address.'" '.$target.'>'.$text.'</a>';
+		}
+
+		return($this->bo->eor($rstring, $return));
+	}
+
+	function html_table_begin($width = NULL, $border = NULL, $cellspacing = NULL, $cellpadding = NULL, $rules = NULL, $string = '', $return = 0)
+	{
+		if($width != NULL && $width)
+		{
+			$width = "width=$width";
+		}
+		if(is_int($border) && $border >= 0)
+		{
+			$border = "border=$border";
+		}
+		if(is_int($cellspacing) && $cellspacing >= 0)
+		{
+			$cellspacing = "cellspacing=$cellspacing";
+		}
+		if(is_int($cellpadding) && $cellpadding >= 0)
+		{
+			$cellpadding = "cellpadding=$cellpadding";
+		}
+		if($rules != NULL && $rules)
+		{
+			$rules = "rules=$rules";
+		}
+
+		$rstring = "<table $width $border $cellspacing $cellpadding $rules $string>";
+		return($this->bo->eor($rstring, $return));
+	}
+
+	function html_table_end($return = 0)
+	{
+		$rstring = "</table>";
+		return($this->bo->eor($rstring, $return));
+	}
+
+	function html_table_row_begin($align = NULL, $halign = NULL, $valign = NULL, $bgcolor = NULL, $string = '', $return = 0)
+	{
+		if($align != NULL && $align)
+		{
+			$align = "align=$align";
+		}
+		if($halign != NULL && $halign)
+		{
+			$halign = "halign=$halign";
+		}
+		if($valign != NULL && $valign)
+		{
+			$valign = "valign=$valign";
+		}
+		if($bgcolor != NULL && $bgcolor)
+		{
+			$bgcolor = "bgcolor=$bgcolor";
+		}
+		$rstring = "<tr $align $halign $valign $bgcolor $string>";
+		return($this->bo->eor($rstring, $return));
+	}
+
+	function html_table_row_end($return = 0)
+	{
+		$rstring = "</tr>";
+		return($this->bo->eor($rstring, $return));
+	}
+
+	function html_table_col_begin($align = NULL, $halign = NULL, $valign = NULL, $rowspan = NULL, $colspan = NULL, $string = '', $return = 0)
+	{
+		if($align != NULL && $align)
+		{
+			$align = "align=$align";
+		}
+		if($halign != NULL && $halign)
+		{
+			$halign = "halign=$halign";
+		}
+		if($valign != NULL && $valign)
+		{
+			$valign = "valign=$valign";
+		}
+		if(is_int($rowspan) && $rowspan >= 0)
+		{
+			$rowspan = "rowspan=$rowspan";
+		}
+		if(is_int($colspan) && $colspan >= 0)
+		{
+			$colspan = "colspan=$colspan";
+		}
+
+		$rstring = "<td $align $halign $valign $rowspan $colspan $string>";
+		return($this->bo->eor($rstring, $return));
+	}
+
+	function html_table_col_end($return = 0)
+	{
+		$rstring = "</td>";
+		return($this->bo->eor($rstring, $return));
+	}
+}
